/*
 *  GTCommonAPI.cpp
 *  All
 *
 *  Created by nhn on 11. 1. 19..
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */
#include "StdAfx.h"
#include <tchar.h>
#include "GTCommonAPI.h"
#include <fcntl.h>
#include <ctime>
#include <sys/stat.h>
#include <Shlwapi.h>
#include "shlobj.h"
#include <atlconv.h>
#include "ConvertUTF.h"


static wchar_t g_wszUUID[128];

size_t GTCommonAPI::StrLen(LPCWSTR str)
{
	return str ? wcslen(str) : 0;
}	

const wchar_t * GTCommonAPI::GetUUID(void)
{
	ASSERT(false);

	return NULL;
}



void GTCommonAPI::GetDeviceUniqueId(char *result, size_t size)
{
	ASSERT(false);
}

void GTCommonAPI::TimeToSystemTime(__time32_t t, LPSYSTEMTIME pst)
{
	struct tm *ptm;
	ptm = _localtime32(&t);
	
	if(!pst)
		return;
	
	pst->wYear = ptm->tm_year + 1900;
	pst->wMonth = ptm->tm_mon + 1;
	pst->wDay = ptm->tm_mday;
	pst->wHour = ptm->tm_hour;
	pst->wMinute = ptm->tm_min;
	pst->wSecond = ptm->tm_sec;
	pst->wMilliseconds = 0;
	pst->wDayOfWeek = ptm->tm_wday;
}


__time32_t GTCommonAPI::SystemTimeToTime(LPSYSTEMTIME pst)
{
	struct tm *ptm;

	__time32_t t = (__time32_t)time(NULL);
	ptm = _localtime32(&t);
	
	if(!pst)
		return 0;
	
	ptm->tm_year = pst->wYear - 1900;
	ptm->tm_mon = pst->wMonth - 1;
	ptm->tm_mday = pst->wDay;
	ptm->tm_hour = pst->wHour;
	ptm->tm_min = pst->wMinute;
	ptm->tm_sec = pst->wSecond;
	
	return (__time32_t)mktime(ptm);
}


unsigned long long GTCommonAPI::GetFileSize(const char *filename)
{
	USES_UTF8_CONVERSION;
	std::wstring wpath = U82W(filename);

	HANDLE hFile = CreateFileW(wpath.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return 0;
    
	DWORD dwRet = ::GetFileSize(hFile, NULL);
	CloseHandle(hFile);
	
	return dwRet;
}


void GTCommonAPI::WriteTextFile(const char *filename, const char *data)
{
	// THERE IS NO USE IN ALL PROJECT..
	ASSERT(false);
}


size_t GTCommonAPI::WriteDataFile(const char *filename, const void *data, size_t size)
{
	USES_UTF8_CONVERSION;
	wchar_t szPath[MAX_PATH] = {0, };
	wcscpy(szPath, U82W(filename));

	PathRemoveFileSpecW(szPath);

	CreateDirectory(W2U8(szPath));
		
	HANDLE hFile; 
	
	hFile = ::CreateFileW(U82W(filename), GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	
	if (hFile == INVALID_HANDLE_VALUE) 
	{ 
		return 0;
	}

	DWORD dwWritten;
	WriteFile(hFile, data, size, &dwWritten, NULL);

	CloseHandle(hFile);
	return dwWritten;
}


bool GTCommonAPI::DeleteFile(const char *src)
{	
    if(strlen(src) <= 0)
        return false;
    
	if(IsDirectory(src))
		return false;
	
	USES_UTF8_CONVERSION;
	std::wstring wpath = U82W(src);

	return ::DeleteFileW(wpath.c_str()) ? true : false;
}


bool GTCommonAPI::MoveFile(const char *src, const char *dst)
{
	DeleteFile(dst);

	USES_UTF8_CONVERSION;
	std::wstring wstr = U82W(src);
	std::wstring wdst = U82W(dst);

	return ::MoveFileW(wstr.c_str(), wdst.c_str()) ? true : false;
}


bool GTCommonAPI::CopyFile(const char *src, const char *dst)
{
	USES_UTF8_CONVERSION;

	std::wstring wstr = U82W(src);
	std::wstring wdst = U82W(dst);

	return ::CopyFileW(wstr.c_str(), wdst.c_str(), FALSE) ? true : false;
}


bool GTCommonAPI::CreateDirectory(const char *path)
{
	USES_UTF8_CONVERSION;
	std::wstring wpath = U82W(path);

	return ::CreateDirectoryW(wpath.c_str(), 0) ? true : false;
}


char * GTCommonAPI::ReadDataFileAlloc(const char *filename, size_t &resultsize)
{
	resultsize = (size_t)GetFileSize(filename);
	if(resultsize <= 0)
		return NULL;
	
	char *resultdata = new char[resultsize + 1];
	memset(resultdata, 0, resultsize + 1);
	
	resultsize = ReadDataFile(filename, resultdata, resultsize);
	
	if(resultsize <= 0)
	{
		delete [] resultdata;
		return NULL;
	}
	
	return resultdata;
}


size_t GTCommonAPI::ReadDataFile(const char *filename, char *result, size_t size)
{
	HANDLE hFile; 
	
	USES_UTF8_CONVERSION;
	std::wstring wpath = U82W(filename);

	hFile = ::CreateFileW(wpath.c_str(),           // open MYFILE.TXT 
		GENERIC_READ,              // open for reading 
		FILE_SHARE_READ | FILE_SHARE_WRITE,           // share for reading 
		NULL,                      // no security 
		OPEN_EXISTING,             // existing file only 
		FILE_ATTRIBUTE_NORMAL,     // normal file 
		NULL);                     // no attr. template 
	
	if (hFile == INVALID_HANDLE_VALUE) 
	{ 
		return 0;
	}

	DWORD dwFileSize = ::GetFileSize( hFile, NULL );
	if (dwFileSize == INVALID_FILE_SIZE)
	{
		CloseHandle( hFile );
		return 0;
	}

	if(dwFileSize > size)
		dwFileSize = size;

	DWORD dwBytesRead = 0;
	DWORD dwTotalRead = 0;
	
	while (dwTotalRead < dwFileSize)
	{ 
		if (!::ReadFile(hFile, result + dwTotalRead, dwFileSize - dwTotalRead, &dwBytesRead, NULL)) 
		{
			break;
		}
		
		dwTotalRead += dwBytesRead;
	}
	result[dwTotalRead] = 0;
	
	::CloseHandle( hFile );
	
	return dwTotalRead;
}

typedef HRESULT (WINAPI * SHGetFolderPathProc)(
    HWND hwndOwner,
    int nFolder,
    HANDLE hToken,
    DWORD dwFlags,
    LPTSTR pszPath
);


static HRESULT _SHGetFolderPath(HWND hwndOwner, int nFolder, HANDLE hToken, DWORD dwFlags, LPWSTR pszPath)
{
	wcscpy(pszPath, _T(""));
	HRESULT hResult;

#ifndef _UNICODE
	hResult = E_FAIL;
#else
	hResult = S_FALSE;
#endif

	HMODULE hModule = LoadLibrary(_T("SHFolder.dll"));
	SHGetFolderPathProc SHGetFolderPath = NULL;
	if(hModule)
	{
#ifndef _UNICODE
		SHGetFolderPath = (SHGetFolderPathProc)GetProcAddress(hModule, "SHGetFolderPathA");
#else
		SHGetFolderPath = (SHGetFolderPathProc)GetProcAddress(hModule, "SHGetFolderPathW");
#endif
		if(SHGetFolderPath)
		{
			hResult = SHGetFolderPath(NULL, CSIDL_LOCAL_APPDATA, NULL, 0, pszPath);
			if(hResult != 0)
			{
				GetWindowsDirectory(pszPath, MAX_PATH);
				wcscpy(pszPath, _T("\\Local Settings\\Application Data"));
				hResult = 0;
			}
		}
	}
	if(hModule)
		FreeLibrary(hModule);

	return hResult;
}


void GTCommonAPI::GetLocalAppPath(char *result, size_t size)
{
	char szPath[MAX_PATH * 2] = {0,};
	WCHAR szAppPath[MAX_PATH * 2] = {0,};

	if(SUCCEEDED(_SHGetFolderPath(NULL, CSIDL_LOCAL_APPDATA, NULL, 0, szAppPath))) 
	{
		USES_CONVERSION;
		strcat(szPath, T2A(szAppPath));
		strcat( szPath, "\\");
		strcat(szPath, "GameTalk");
	}
	
	_snprintf(result, size-1, "%s", szPath);
}


bool GTCommonAPI::IsDirectory(const char *path)
{
	USES_UTF8_CONVERSION;
	std::wstring wpath = U82W(path);

	return PathIsDirectoryW(wpath.c_str()) ? true : false;
}


bool GTCommonAPI::IsFileExist(const char *fileFullPath)
{
	USES_UTF8_CONVERSION;
	std::wstring wpath = U82W(fileFullPath);

	return PathFileExistsW(wpath.c_str()) ? true : false;
}

std::string GTCommonAPI::GetOsVersion()
{
	ASSERT(false);
	return "windows";
}

/*
 Platforms
 
 iFPGA ->		??
 
 iPhone1,1 ->	iPhone 1G
 iPhone1,2 ->	iPhone 3G
 iPhone2,1 ->	iPhone 3GS
 iPhone3,1 ->	iPhone 4/AT&T
 iPhone3,2 ->	iPhone 4/Other Carrier?
 iPhone3,3 ->	iPhone 4/Other Carrier?
 iPhone4,1 ->	??iPhone 5
 
 iPod1,1   -> iPod touch 1G 
 iPod2,1   -> iPod touch 2G 
 iPod2,2   -> ??iPod touch 2.5G
 iPod3,1   -> iPod touch 3G
 iPod4,1   -> iPod touch 4G
 iPod5,1   -> ??iPod touch 5G
 
 iPad1,1   -> iPad 1G, WiFi
 iPad1,?   -> iPad 1G, 3G <- needs 3G owner to test
 iPad2,1   -> iPad 2G (iProd 2,1)
 
 AppleTV2,1 -> AppleTV 2
 
 i386, x86_64 -> iPhone Simulator
 */
std::string GTCommonAPI::GetDeviceVersion()
{
	ASSERT(false);
	return "i386";
}


void GTCommonAPI::PrintLog(const char *log)
{
	::OutputDebugStringA(log);
}

// EOF
